var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, ChangeDetectionStrategy, ViewChild, ElementRef, Input, Output, EventEmitter } from '@angular/core';
import * as Chart from 'chart.js';
var ChartComponent = (function () {
    function ChartComponent() {
        this.chartCreated = new EventEmitter();
        this.canvasClick = new EventEmitter();
    }
    ChartComponent.prototype.ngAfterViewInit = function () {
        this.chart = new Chart(this.canvas.nativeElement, {
            type: this.type,
            data: this.data,
            options: this.options
        });
        this.chartCreated.emit(this);
    };
    ChartComponent.prototype.ngOnChanges = function (changes) {
        if (this.chart && changes['data']) {
            var currentValue = changes['data'].currentValue;
            this.updateChartData(currentValue);
        }
    };
    ChartComponent.prototype.onCanvasClick = function ($event) {
        this.canvasClick.emit(this);
    };
    ChartComponent.prototype.toBase64Image = function () {
        this.chart.toBase64Image();
    };
    ChartComponent.prototype.resize = function () {
        this.chart.resize();
    };
    ChartComponent.prototype.render = function (duration, lazy) {
        if (duration === void 0) { duration = 0; }
        if (lazy === void 0) { lazy = false; }
        this.chart.render(duration, lazy);
    };
    ChartComponent.prototype.update = function (data, duration, lazy) {
        if (duration === void 0) { duration = 0; }
        if (lazy === void 0) { lazy = false; }
        this.updateChartData(data || {});
        this.chart.update(duration, lazy);
    };
    ChartComponent.prototype.stop = function () {
        this.chart.stop();
    };
    ChartComponent.prototype.updateChartData = function (currentValue) {
        var _this = this;
        ['datasets', 'labels', 'xLabels', 'yLabels'].forEach(function (key) {
            _this.chart.data[key] = currentValue[key];
        });
        this.chart.update();
    };
    ChartComponent.prototype.ngOnDestroy = function () {
        if (this.chart) {
            this.chart.destroy();
        }
    };
    return ChartComponent;
}());
__decorate([
    Input(),
    __metadata("design:type", String)
], ChartComponent.prototype, "type", void 0);
__decorate([
    Input(),
    __metadata("design:type", Object)
], ChartComponent.prototype, "data", void 0);
__decorate([
    Input(),
    __metadata("design:type", Object)
], ChartComponent.prototype, "options", void 0);
__decorate([
    Output(),
    __metadata("design:type", Object)
], ChartComponent.prototype, "chartCreated", void 0);
__decorate([
    Output(),
    __metadata("design:type", Object)
], ChartComponent.prototype, "canvasClick", void 0);
__decorate([
    ViewChild('canvas'),
    __metadata("design:type", ElementRef)
], ChartComponent.prototype, "canvas", void 0);
ChartComponent = __decorate([
    Component({
        selector: 're-chart',
        template: "\n    <canvas #canvas (click)=\"onCanvasClick($event)\"></canvas>\n  ",
        styles: ["\n    :host{display:block}\n  "],
        changeDetection: ChangeDetectionStrategy.OnPush,
        exportAs: 'chart'
    })
], ChartComponent);
export { ChartComponent };
//# sourceMappingURL=chart.component.js.map