var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, ChangeDetectionStrategy, ElementRef, Input, Output, EventEmitter } from '@angular/core';
import * as echarts from 'echarts';
var EChartsComponent = (function () {
    // event: 'click'、'dblclick'、'mousedown'、'mousemove'、'mouseup'、'mouseover'、'mouseout'
    function EChartsComponent(elementRef) {
        this.elementRef = elementRef;
        this.width = '100%';
        this.height = '400px';
        this.chartCreated = new EventEmitter();
    }
    EChartsComponent.prototype.ngAfterViewInit = function () {
        this.chart = echarts.init(this.elementRef.nativeElement);
        this.updateChartData(this.options);
        this.chartCreated.emit(this);
    };
    EChartsComponent.prototype.ngOnChanges = function (changes) {
        if (this.chart && changes['options']) {
            var currentValue = changes['options'].currentValue;
            this.updateChartData(currentValue);
        }
    };
    EChartsComponent.prototype.ngOnDestroy = function () {
        if (this.chart) {
            this.chart.destroy();
        }
    };
    EChartsComponent.prototype.updateChartData = function (options) {
        if (options) {
            this.chart.setOption(options);
        }
    };
    return EChartsComponent;
}());
__decorate([
    Input(),
    __metadata("design:type", Object)
], EChartsComponent.prototype, "options", void 0);
__decorate([
    Input(),
    __metadata("design:type", Object)
], EChartsComponent.prototype, "width", void 0);
__decorate([
    Input(),
    __metadata("design:type", Object)
], EChartsComponent.prototype, "height", void 0);
__decorate([
    Output(),
    __metadata("design:type", Object)
], EChartsComponent.prototype, "chartCreated", void 0);
EChartsComponent = __decorate([
    Component({
        selector: 're-echarts',
        template: '',
        host: {
            '[style.display]': '"block"',
            '[style.width]': 'width',
            '[style.height]': 'height'
        },
        changeDetection: ChangeDetectionStrategy.OnPush,
        exportAs: 'chart'
    }),
    __metadata("design:paramtypes", [ElementRef])
], EChartsComponent);
export { EChartsComponent };
//# sourceMappingURL=echarts.component.js.map